#include "Cir2Puertos.h"

extern PegBitmap gbcir_tBitmap;
extern PegBitmap gbcir_piBitmap;

Cir2Puertos::Cir2Puertos(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int Cir2Puertos::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
   	PEGCHAR* chrohm = "\xEC\x7E"; 

    PegRect rectangle;
 
 	PegPrompt* label1 = new PegPrompt(margin, 80, width, "R1("+CPString(chrohm)+"):",0,wStyle);
	R1 = new CPPegString(margin+40,80,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(R1);
	AddR(label1);
	
 	PegPrompt* label2 = new PegPrompt(margin, 95, width, "R2("+CPString(chrohm)+"):",0,wStyle);
	R2 = new CPPegString(margin+40,95,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(R2);
	AddR(label2);

 	PegPrompt* label3 = new PegPrompt(margin, 110, width, "R3("+CPString(chrohm)+"):",0,wStyle);
	R3 = new CPPegString(margin+40,110,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(R3);
	AddR(label3);

 	PegPrompt* label4 = new PegPrompt(margin, 130, width, "Calcular:",0,wStyle);
	AddR(label4);

     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(62, 130, 80, 145);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Z", MATZ, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
    rectangle.Set(83, 130, 101, 145);
   	PegTextButton* b4 = new PegTextButton(rectangle, "Y", MATY, AF_ENABLED|TJ_CENTER);
	AddR(b4);
	
    rectangle.Set(104, 130, 122, 145);
   	PegTextButton* b5 = new PegTextButton(rectangle, "H", MATH, AF_ENABLED|TJ_CENTER);
	AddR(b5);
	
    rectangle.Set(125, 130, 143, 145);
   	PegTextButton* b6 = new PegTextButton(rectangle, "G", MATG, AF_ENABLED|TJ_CENTER);
	AddR(b6);
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+75);
 	imatge = new PegBitmapButton(rectangle,&gbcir_tBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 
 	
	nom_mat = new PegPrompt(margin, 158, width, "",0,wStyle);
	AddR(nom_mat);

	elm11 = new PegPrompt(45, 152, 50, "",0,wStyle);
	AddR(elm11);

	elm12 = new PegPrompt(90, 152, 50, "",0,wStyle);
	AddR(elm12);

	elm21 = new PegPrompt(45, 162, 50, "",0,wStyle);
	AddR(elm21);

	elm22 = new PegPrompt(90, 162, 50, "",0,wStyle);
	AddR(elm22);

	det = new PegPrompt(margin, 180, width, "",0,wStyle);
	AddR(det);

    mode = 0;
    
	return 0;
}

void Cir2Puertos::AddUI()
{
// create text buttons for the toolbar
PegTextButton* b1 = new PegTextButton(1,1, "Circuito T", CIR_T, AF_ENABLED|TT_COPY);
PegTextButton* b2 = new PegTextButton(2,1, "Circuito Pi", CIR_PI, AF_ENABLED|TT_COPY);

//position and enable the buttons
m_ui->AddToolbarButton(b1);
m_ui->AddToolbarButton(b2);
}

void Cir2Puertos::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED Cir2Puertos::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(MATZ, PSF_CLICKED):
		{
		    if(campsBuits())
              Dialog("Error","Faltan valores de R!");   

            else    
            {
                if(mode==0)    
                    CalculaZ();
                else
                    CalculaZ_pi();
            }    
		}
		break;
		case SIGNAL(MATY, PSF_CLICKED):
		{
  		    if(campsBuits())
              Dialog("Error","Faltan valores de R!");   

            else    
            {
                if(mode==0)    
                    CalculaY();
                else
                    CalculaY_pi();
            }    
		}
		break;
		case SIGNAL(MATH, PSF_CLICKED):
		{
		    if(campsBuits())
               Dialog("Error","Faltan valores de R!");   

            else    
            {
                if(mode==0)    
                    CalculaH();
                else
                    CalculaH_pi();
            }    
		}
		break;
		case SIGNAL(MATG, PSF_CLICKED):
		{
 		    if(campsBuits())
                Dialog("Error","Faltan valores de R!");   

            else
            {
                if(mode==0)    
                    CalculaG();
                else
                    CalculaG_pi();
            }    
		}
		break;
		case SIGNAL(CIR_T, PSF_CLICKED):
		{
 		    mode = 0;
 		    imatge->SetBitmap(&gbcir_tBitmap);
 		    Buida();
		}
		break;
		case SIGNAL(CIR_PI, PSF_CLICKED):
		{
 		    mode = 1;
 		    imatge->SetBitmap(&gbcir_piBitmap);
 		    Buida();
		}
		break;		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

void Cir2Puertos::Buida()
{
     R1->DataSet("");
     R2->DataSet("");
     R3->DataSet("");
     elm11->DataSet("");
     elm12->DataSet("");
     elm21->DataSet("");
     elm22->DataSet("");
     nom_mat->DataSet("");
     det->DataSet("");
     Draw();
}
    
WORD Cir2Puertos::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void Cir2Puertos::CalculaZ()
{
    OBCD aux,aux2, z11, z22, z12, z21;
    
    aux = CPExpression(R1->DataGet());
    aux2 = CPExpression(R3->DataGet());
    Cal_add_OBC(&aux,&aux2); 
    z11 = aux; 
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
    
    z21 = aux2;
    Cal_cintx_OBC(&aux2,4);
    elm21->DataSet(CPString(aux2));

    aux = CPExpression(R2->DataGet());
    aux2 = CPExpression(R3->DataGet());
    Cal_add_OBC(&aux,&aux2);
    z22 = aux;
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));

    z12 = aux2;
    Cal_cintx_OBC(&aux2,4);
    elm12->DataSet(CPString(aux2));

    nom_mat->DataSet("Z = (              )");
    
    aux = z11;
    Cal_mul_OBC(&aux,&z22);
    aux2 = z12;
    Cal_mul_OBC(&aux2,&z21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw();
}   

void Cir2Puertos::CalculaY()
{
    OBCD aux,aux2, y11, y22, y12, y21, Req;
    
    Req  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R3->DataGet()));
    aux2 = CPExpression(R1->DataGet());
    Cal_add_OBC(&aux2,&Req);
    Cal_inverse_OBC(&aux2);
    y11 = aux2;
    Cal_cintx_OBC(&aux2,4);
    elm11->DataSet(CPString(aux2));
    
    aux2 = CPExpression(R1->DataGet());
    Cal_add_OBC(&aux2,&Req);
    Cal_inverse_OBC(&aux2);
    Cal_mul_OBC(&aux2,&Req);
    aux = CPExpression(R2->DataGet());
    Cal_div_OBC(&aux2,&aux);
    Cal_minus_OBC(&aux2);
    y21 = aux2;
    Cal_cintx_OBC(&aux2,3);
    elm21->DataSet(CPString(aux2));

    Req  = calculaRParalel(CPExpression(R1->DataGet()),CPExpression(R3->DataGet()));
    aux2 = CPExpression(R2->DataGet());
    Cal_add_OBC(&aux2,&Req);
    Cal_inverse_OBC(&aux2);
    y22 = aux2;
    Cal_cintx_OBC(&aux2,4);
    elm22->DataSet(CPString(aux2));

    aux2 = CPExpression(R2->DataGet());
    Cal_add_OBC(&aux2,&Req);
    Cal_inverse_OBC(&aux2);
    Cal_mul_OBC(&aux2,&Req);
    aux = CPExpression(R1->DataGet());
    Cal_div_OBC(&aux2,&aux);
    Cal_minus_OBC(&aux2);
    y12 = aux2;
    Cal_cintx_OBC(&aux2,3);
    elm12->DataSet(CPString(aux2));
    
    nom_mat->DataSet("Y = (               )");

    aux = y11;
    Cal_mul_OBC(&aux,&y22);
    aux2 = y12;
    Cal_mul_OBC(&aux2,&y21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw();
}   

void Cir2Puertos::CalculaG()
{
      OBCD aux, aux2, g11, g12, g21, g22;
    
    g11 = CPExpression(R1->DataGet());
    aux = CPExpression(R3->DataGet());
    Cal_add_OBC(&g11,&aux);
    Cal_inverse_OBC(&g11);
    aux = g11;
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
    
    g21 = CPExpression(R3->DataGet());
    Cal_mul_OBC(&g21,&g11);
    aux = g21;
    Cal_cintx_OBC(&aux,4);
    elm21->DataSet(CPString(aux));
   
    g12 = g21;
    Cal_minus_OBC(&g12);
    aux = g12;
    Cal_cintx_OBC(&aux,3);
    elm12->DataSet(CPString(aux));


    g22 = CPExpression(R2->DataGet());
    aux = CPExpression(R3->DataGet());
    Cal_add_OBC(&g22,&aux);
    Cal_inverse_OBC(&g22);
    aux = g22;
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));
      
    nom_mat->DataSet("G = (               )");

    aux = g11;
    Cal_mul_OBC(&aux,&g22);
    aux2 = g12;
    Cal_mul_OBC(&aux2,&g21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw(); 
}   

void Cir2Puertos::CalculaH()
{
    OBCD aux, aux2, h11, h12, h21, h22, Req;
    
    Req  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R3->DataGet()));
    h11 = CPExpression(R1->DataGet());
    Cal_add_OBC(&h11,&Req);
    aux = h11;
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
    
    h22 = CPExpression(R2->DataGet());
    aux = CPExpression(R3->DataGet());
    Cal_add_OBC(&h22,&aux);
    Cal_inverse_OBC(&h22);
    aux = h22;
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));
   
    h21 = h22;
    aux = CPExpression(R3->DataGet());
    Cal_mul_OBC(&h21,&aux);
    h12 = h21;
    Cal_minus_OBC(&h21);
    aux = h21;
    Cal_cintx_OBC(&aux,4);
    elm21->DataSet(CPString(aux));
  
    aux = h12;
    Cal_cintx_OBC(&aux,4);
    elm12->DataSet(CPString(aux));
  
    nom_mat->DataSet("H = (               )");

    aux = h11;
    Cal_mul_OBC(&aux,&h22);
    aux2 = h12;
    Cal_mul_OBC(&aux2,&h21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw();
}   

bool Cir2Puertos::campsBuits()
{
    if(R1->DataGet() == NULL) return true;
    if(R2->DataGet() == NULL) return true;
    if(R3->DataGet() == NULL) return true;
    return false;
}

OBCD Cir2Puertos::calculaRParalel(OBCD Ra, OBCD Rb)
{
     OBCD aux;
     aux = Ra;
     Cal_add_OBC(&aux,&Rb);
     Cal_inverse_OBC(&aux);
     Cal_mul_OBC(&aux,&Ra);
     Cal_mul_OBC(&aux,&Rb);
     return aux;
}

void Cir2Puertos::CalculaZ_pi()
{
    OBCD aux, aux2, z11, z12, z21, z22;
    
    aux = CPExpression(R2->DataGet());
    aux2 = CPExpression(R3->DataGet());
    Cal_add_OBC(&aux,&aux2);
    z11  = calculaRParalel(aux,CPExpression(R1->DataGet()));
    aux = z11;   
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
  
    aux = CPExpression(R2->DataGet());
    Cal_add_OBC(&aux2,&aux);
    aux = CPExpression(R1->DataGet());
    Cal_add_OBC(&aux2,&aux);
    aux = CPExpression(R1->DataGet());
    Cal_div_OBC(&aux,&aux2);
    aux2 = CPExpression(R3->DataGet());
    Cal_mul_OBC(&aux2,&aux);
    z21 = z12 = aux2;
    Cal_cintx_OBC(&aux2,3);
    elm12->DataSet(CPString(aux2));
    elm21->DataSet(CPString(aux2));
    
    aux = CPExpression(R2->DataGet());
    aux2 = CPExpression(R1->DataGet());
    Cal_add_OBC(&aux,&aux2);
    z22  = calculaRParalel(aux,CPExpression(R3->DataGet()));
    aux = z22;   
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));

    nom_mat->DataSet("Z = (               )");

    aux = z11;
    Cal_mul_OBC(&aux,&z22);
    aux2 = z12;
    Cal_mul_OBC(&aux2,&z21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw(); 
 
}
void Cir2Puertos::CalculaY_pi()
{
    OBCD aux, aux2, y11, y12, y21, y22;
    
    y11  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R1->DataGet()));
    Cal_inverse_OBC(&y11);
    aux = y11;   
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
  
    y12 = CPExpression(R2->DataGet());
    Cal_inverse_OBC(&y12);
    Cal_minus_OBC(&y12);
    aux = y21 = y12;
    Cal_cintx_OBC(&aux,3);
    elm12->DataSet(CPString(aux));
    elm21->DataSet(CPString(aux));
    
    y22  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R3->DataGet()));
    Cal_inverse_OBC(&y22);
    aux = y22;   
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));

    nom_mat->DataSet("Y = (               )");

    aux = y11;
    Cal_mul_OBC(&aux,&y22);
    aux2 = y12;
    Cal_mul_OBC(&aux2,&y21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw(); 
}
void Cir2Puertos::CalculaH_pi()
{
    OBCD aux, aux2, h11, h12, h21, h22;
    
    h11  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R1->DataGet()));
    aux = h11;   
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
  
    aux = CPExpression(R2->DataGet());
    h12 = CPExpression(R1->DataGet());
    Cal_add_OBC(&aux,&h12);
    aux2 = aux;
    Cal_div_OBC(&h12,&aux);
    aux = h12;
    Cal_cintx_OBC(&aux,4);
    elm12->DataSet(CPString(aux));
    h21 = h12;
    Cal_minus_OBC(&h21);
    aux = h21;
    Cal_cintx_OBC(&aux,3);
    elm21->DataSet(CPString(aux));
    
    
    h22  = calculaRParalel(aux2,CPExpression(R3->DataGet()));
    Cal_inverse_OBC(&h22);
    aux = h22;   
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));

    nom_mat->DataSet("H = (               )");

    aux = h11;
    Cal_mul_OBC(&aux,&h22);
    aux2 = h12;
    Cal_mul_OBC(&aux2,&h21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw(); 

}
void Cir2Puertos::CalculaG_pi()
{
     OBCD aux, aux2, g11, g12, g21, g22;
    
    aux = CPExpression(R2->DataGet());
    aux2 = CPExpression(R3->DataGet());
    Cal_add_OBC(&aux,&aux2);
    g11  = calculaRParalel(aux,CPExpression(R1->DataGet()));
    Cal_inverse_OBC(&g11);
    aux = g11;   
    Cal_cintx_OBC(&aux,4);
    elm11->DataSet(CPString(aux));
  
    aux = CPExpression(R2->DataGet());
    Cal_add_OBC(&aux,&aux2);
    Cal_div_OBC(&aux2,&aux);
    Cal_minus_OBC(&aux2);
    g12 = aux2;
    Cal_cintx_OBC(&aux2,3);
    elm12->DataSet(CPString(aux2));

    aux2 = CPExpression(R1->DataGet());
    aux = CPExpression(R2->DataGet());
    Cal_add_OBC(&aux,&aux2);
    Cal_div_OBC(&aux,&aux2);
    g21 = aux;
    Cal_cintx_OBC(&aux,4);
    elm21->DataSet(CPString(aux));
    
    g22  = calculaRParalel(CPExpression(R2->DataGet()),CPExpression(R3->DataGet()));
    aux = g22;
    Cal_cintx_OBC(&aux,4);
    elm22->DataSet(CPString(aux));

    nom_mat->DataSet("G = (               )");

    aux = g11;
    Cal_mul_OBC(&aux,&g22);
    aux2 = g12;
    Cal_mul_OBC(&aux2,&g21);
    Cal_sub_OBC(&aux,&aux2);
    
    det->DataSet("det = "+CPString(aux));

    Draw(); 
}
   
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
